## 基本信息

**参赛方向：** 小型内核实现 
**队伍编号：** T202410359994432 
**队伍名：** LH 

## 项目简介

本项目是一个从零开始开发操作系统内核设计。

## 开发环境与运行方式

### 开发环境

- Ububtu-22.04
- qemu-system-riscv64
- riscv64-unknown-elf-gcc
- [rustsbi](https://github.com/rustsbi/rustsbi)

### 运行方式

**make**
确保安装了上述工具以及其他必要的开发环境
```
make run
```

**debug**
如果你希望 `DEBUG` ，使用 `export DEBUG=y`， 然后 `make run`，即可使用 riscv-gdb 进行调试。

项目中的一些配置信息在 `config/config.json` 中，可进行相关配置。

**clean**
清理环境
```
make clean
```

**vscode**

可直接使用 vscode 调试前端进行调试、构建项目或清理项目。

## 开发路线

首先实现了一些基本的函数库，然后实现基本内存管理，时钟中断，随后实现了 虚拟内存 sv39 ，而后实现了进程基础功能，随后设计了一个简单的文件系统。开发的想法是从头到尾走一遍，然后对各部分进行优化，实现更优策略，使用更优算法。

详见 `docs` 目录。

## 参考资料

[xv6-riscv](https://github.com/mit-pdos/xv6-riscv)