## config

在 `config/config.json` 中，可以相关内容的配置。

思路是可以按照 Debug、Build 模式去进行相应配置，System 用于配置各种操作系统选项。

`config/config.py` 会对这个 `config.json` 进行解析，生成对应的 `config.h` 文件，其中包含相应的宏定义。
在各个文件中 `include` `config.h` 之后，即可按照配置选项执行相应功能，如 Debug 模式下，可以选择想要打印相关信息的函数。

## Trap

中断向量位于 `trap_v.S`中，其中会保存关键寄存器，然后跳转至 `trap_handler` 函数，在该函数中会进一步细分 `interrupt` `exception`，根据 `scause` 寄存器中相应的值执行相应的处理函数。

## 虚拟内存

实现了 riscv sv39 三级页表。实现了基本的虚拟内存映射、回收、页表复制、范围回收、检查权限等。

## fs

关于磁盘部分 `disk.c` 以及相关的部分来自于 `xv6-riscv`，对其做了简单的修改，用于适配。

实现了基本的文件操作，并实现了用于本项目的简单的磁盘格式化工具。

## 总结

整个项目，这与时间分配不足有关。原本是希望能各个部分简单实现，然后各个部分去逐步优化，但由于各种各样的因素，没能做到。之后继续努力。
