#ifndef PRINTF_H
#define PRINTF_H

#include "type.h"
#include "sbi.h"
#include "stdarg.h"
#include "stdbool.h"

#define PRINTK_BUF_SIZE 1024

int printk(const char *format, ...);
int sprintk(char *out, const char *format, ...);
int snprintf(char *out, size_t n, const char *format, ...);
int vsnprintk(char *out, size_t n, const char *format, va_list args);
int vsprintk(char *out, const char *format, va_list args);
int vprintk(const char *format, va_list args);

#ifndef putchar
#define putchar(ch) sbi_console_putchar(ch)
#endif


#endif