#ifndef RISCV_H
#define RISCV_H
#define PAGE_SIZE 4096
#define MEM_START 0;

#define SSTATUS_SIE 0x2
#define SSTATUS_SPIE 0x20
#define SSTATUS_SPP 0x100
#define SSTATUS_SUM 0x400
#define SSTATUS_FS 0x1000

#define SIE_SEIE 0x80
#define SIE_STIE 0x20
#define SIE_SSIE 0x2

#define read_csr(reg) ({ unsigned long __tmp; \
    asm volatile ("csrr %0, " #reg : "=r"(__tmp)); \
    __tmp; })
#define write_csr(reg, val) ({ \
    asm volatile ("csrw " #reg ", %0" :: "rK"(val)); })

#define SATP_MODE_MASK (0xF << 60)

#define MAKE_SATP(pagetable) \
    ((8L << 60) | (((uint64_t)pagetable) >> 12))

#endif