#include "include/stdlib.h"

void *malloc(size_t size)
{
    TODO();
    return NULL;
}

void free(void *ptr)
{
    TODO();
}
bool isspace(int c)
{
    return c == ' ' || (c >= '\t' && c <= '\r');
}

int atoi(const char *str)
{
    int result = 0;
    int sign = 1;
    if (*str == '-')
    {
        sign = -1;
        str++;
    }
    while (*str)
    {
        result = result * 10 + *str - '0';
        str++;
    }
    return sign * result;
}

long atol(const char *str) {
    long result = 0;
    int sign = 1;
    if (*str == '-') {
        sign = -1;
        str++;
    }
    while (*str) {
        result = result * 10 + *str - '0';
        str++;
    }
    return sign * result;
}

long strtol(const char *nptr, char **endptr, int base) {
    long ret = 0;
    bool neg = false;
    const char *p = nptr;

    while (isspace(*p)) {
        p++;
    }

    if (*p == '-') {
        neg = true;
        p++;
    }
    else if (*p == '+') {
        p++;
    }

    if (base == 0) {
        if (*p == '0') {
            p++;
            if (*p == 'x' || *p == 'X') {
                base = 16;
                p++;
            }
            else {
                base = 8;
            }
        }
        else {
            base = 10;
        }
    }

    while (1) {
        int digit;
        if (*p >= '0' && *p <= '9') {
            digit = *p - '0';
        }
        else if (*p >= 'a' && *p <= 'z') {
            digit = *p - ('a' - 10);
        }
        else if (*p >= 'A' && *p <= 'Z') {
            digit = *p - ('A' - 10);
        }
        else {
            break;
        }

        if (digit >= base) {
            break;
        }

        ret = ret * base + digit;
        p++;
    }

    if (endptr) {
        *endptr = (char *)p;
    }

    return neg ? -ret : ret;
}

unsigned long strtoul(const char *nptr, char **endptr, int base) {
    unsigned long ret = 0;
    const char *p = nptr;

    while (isspace(*p)) {
        p++;
    }

    if (base == 0) {
        if (*p == '0') {
            p++;
            if (*p == 'x' || *p == 'X') {
                base = 16;
                p++;
            }
            else {
                base = 8;
            }
        }
        else {
            base = 10;
        }
    }

    while (1) {
        int digit;
        if (*p >= '0' && *p <= '9') {
            digit = *p - '0';
        }
        else if (*p >= 'a' && *p <= 'z') {
            digit = *p - ('a' - 10);
        }
        else if (*p >= 'A' && *p <= 'Z') {
            digit = *p - ('A' - 10);
        }
        else {
            break;
        }

        if (digit >= base) {
            break;
        }

        ret = ret * base + digit;
        p++;
    }

    if (endptr) {
        *endptr = (char *)p;
    }

    return ret;
}