OUTPUT_ARCH(riscv)
ENTRY(_start)
BASE_ADDRESS = 0x80200000;
SECTIONS
{
    . = BASE_ADDRESS;
    __kernel_start = .;
    .text : 
    { 
      __text_start = .;
      *(.text.entry)
      *(.text)
      *(.rodata)
      __text_end = .;
    }

    . = ALIGN(4K);
    .data : 
    {
      __data_start = .;
        *(.data)
      __data_end = .;
    }

    . = ALIGN(4K);
    .bss : 
    {
        __bss_start = .;
        *(.bss)
        *(COMMON)
        __bss_end = .;
    }

    . = ALIGN(4K);
    .stack :
    {
        __stack_start = .;
        *(.stack)
        . = . + 4096 * 4;
        __stack_end = .;
    }

    PROVIDE(__kernel_stack = __stack_start);
    PROVIDE(__kernel_stack_top = __stack_end);
    PROVIDE(__kernel_end = .);
}
